---
title: Headers.getAll()
slug: Web/API/Headers/getAll
tags:
  - API
  - Experimental
  - Fetch
  - Headers
  - Method
  - Obsolete
  - Reference
  - getAll
---
<p>{{obsolete_header("gecko52")}}{{APIRef("Fetch")}}{{ SeeCompatTable() }}</p>

<p>The <strong><code>getAll()</code></strong> method of the {{domxref("Headers")}} interface used to return an array of all the values of a header within a <code>Headers</code> object with a given name; in newer versions of the Fetch spec, it has been deleted, and {{domxref("Headers.get()")}} has been updated to fetch <em>all</em> header values instead of only the first one.</p>

<p><span style="line-height: 19.0909080505371px;">If the requested header doesn't exist</span> in the <code>Headers</code> object, it returns an empty array.</p>

<p>For security reasons, some headers can only be controller by the user agent. These headers include the {{Glossary("Forbidden_header_name", "forbidden header names", 1)}}  and {{Glossary("Forbidden_response_header_name", "forbidden response header names", 1)}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js">myHeaders.getAll(name);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><em>name</em></dt>
 <dd>The name of the HTTP header whose values you want to retrieve from the <code>Headers</code> object. <span style="line-height: 19.0909080505371px;">If the given name is not the name of an HTTP header</span><span style="line-height: 19.0909080505371px;">, this method throws a </span><span style="line-height: 19.0909080505371px;">{{jsxref("TypeError")}}.</span></dd>
</dl>

<h3 id="Returns">Returns</h3>

<p>An {{domxref("Array")}} containing a {{domxref("ByteString")}} sequence representing the values of the retrieved header.</p>

<h2 id="Example">Example</h2>

<p>Creating an empty <code>Headers</code> object is simple:</p>

<pre class="brush: js">var myHeaders = new Headers(); // Currently empty</pre>

<p>You could add a header to this using {{domxref("Headers.append")}}, then retrieve it using <code>getAll()</code>:</p>

<pre class="brush: js">myHeaders.append('Content-Type', 'image/jpeg');
myHeaders.getAll('Content-Type'); // Returns [ "image/jpeg" ]
</pre>

<p>If the header has multiple values associated with it, the array will contain all the values, in the order they were added to the Headers object:</p>

<pre class="brush: js">myHeaders.append('Accept-Encoding', 'deflate');
myHeaders.append('Accept-Encoding', 'gzip');
myHeaders.getAll('Accept-Encoding'); // Returns [ "deflate", "gzip" ]</pre>

<div class="note">
<p><strong>Note</strong>: Use {{domxref("Headers.get")}} to return only the first value added to the <code>Headers</code> object.</p>
</div>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Headers.getAll")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API">ServiceWorker API</a></li>
 <li><a href="/en-US/docs/Web/HTTP/Access_control_CORS">HTTP access control (CORS)</a></li>
 <li><a href="/en-US/docs/Web/HTTP">HTTP</a></li>
</ul>
